%    This file is part of the psPack simulation package from the
%    doctoral dissertation "A DAE Formulation for Multi-Zone
%    Application to CVCP Engines" by Per Öberg. 
%    The dissertation is available at 
%    http://urn.kb.se/resolve?urn=urn:nbn:se:liu:diva-18120
%
%    Copyright (C) 2013  Per Öberg <per.oberg@liu.se>
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License along
%    with this program; if not, write to the Free Software Foundation, Inc.,
%    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
function outValue =  psCalcDepVars(psStruct)
outValue = 1;  

if ~isfield(psStruct,'varInfo')
    fNames=fieldnames(psStruct);
    for ii = 1:length(fNames)
        if psStruct.(fNames{ii}).varInfo.initialized
            psStruct.(fNames{ii}) = psCalcSubGroup(psStruct.(fNames{ii}));
        end
    end
    outValue = psStruct;
else
    outValue=psCalcSubGroup(psStruct);
end    
    
function out = psCalcSubGroup(psStruct)    
if isfield(psStruct.varInfo,'depVarNames')
    for tmpIdx = 1:length(psStruct.varInfo.depVarNames)
        varName = psStruct.varInfo.depVarNames{tmpIdx};
        funcName = psStruct.varInfo.depVarFuncs{tmpIdx};
        if iscell(funcName)
            parNames ={};
        else
            parNames = symvar(funcName);
            argStr = [];
            for tmpIdx2 = 1:length(parNames)
                if isempty(argStr)
                    argStr = ['psStruct.(''' parNames{tmpIdx2} ''')'];
                else
                    argStr = [argStr ',psStruct.(''' parNames{tmpIdx2} ''')' ];
                end
            end
        end
        if iscell(funcName)
            psStruct.(varName) = psStruct.varInfo.depVarFuncs{tmpIdx}{1};
        else
            psStruct.(varName) = eval(['psStruct.varInfo.depVarFuncs{tmpIdx}(' argStr ')']);
        end
    end


    theNames = psStruct.varInfo.varNames;
    theLength = length(theNames);
    theNames{theLength+1} = 'varInfo';
    if length(fieldnames(psStruct)) == length(theNames)
        psStruct = orderfields(psStruct,theNames);
    else
        disp('You have added extra variables. Skipping ordering of fields.')
    end
end
out = psStruct;
