%    This file is part of the psPack simulation package from the
%    doctoral dissertation "A DAE Formulation for Multi-Zone
%    Application to CVCP Engines" by Per Öberg. 
%    The dissertation is available at 
%    http://urn.kb.se/resolve?urn=urn:nbn:se:liu:diva-18120
%
%    Copyright (C) 2013  Per Öberg <per.oberg@liu.se>
%
%    This program is free software; you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation; either version 2 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License along
%    with this program; if not, write to the Free Software Foundation, Inc.,
%    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
function outValue =  psCheckConsistency(psStruct)

outValue = 1;  

for tmpIdx = 1:length(psStruct.varInfo.depVarNames)
  varName = psStruct.varInfo.depVarNames{tmpIdx};
  funcName = psStruct.varInfo.depVarFuncs{tmpIdx};
  parNames = symvar(funcName);
  argStr = [];
  for tmpIdx2 = 1:length(parNames)
    if isempty(argStr)
      argStr = ['psStruct.(''' parNames{tmpIdx2} ''')'];
    else
      argStr = [argStr ',psStruct.(''' parNames{tmpIdx2} ''')' ];
    end
  end
  if psStruct.(varName) ~= eval(['psStruct.varInfo.depVarFuncs{tmpIdx}(' argStr ')'])
    outValue = 0;
  end
end
